# -*- coding: utf-8 -*-
from django.contrib.auth.forms import *
from django.shortcuts import render_to_response as render
from django.http import HttpResponseRedirect, HttpResponse
from django.template import RequestContext, loader, Context

from django_authopenid.forms import *
from youloc.youlocapp.models import LatestLocation
from youloc.userprofile.models import UserProfileForm

def reverse_geonames_lookup(latitude, longitude): # TODO: Put to a helper-function-file
    try:
        from BeautifulSoup import BeautifulStoneSoup
    except:
        return ''
    from urllib2 import urlopen
    geonames = urlopen('http://ws.geonames.org/findNearby?lat='+str(latitude)+'&lng='+str(longitude))
    soup = BeautifulStoneSoup(geonames.read())
    geoname = soup.findAll('name')[0].string
    return str(geoname+" ("+soup.countryname.string+")")
    
def home(request):
    if request.method == "POST":
        submitted_profile = request.POST.copy()
        submitted_profile['user'] = request.user.id
        profile = UserProfileForm(submitted_profile, instance=request.user.get_profile())
        if profile.is_valid():
            profile.save()
    else:
        try:
            profile = request.user.get_profile()
        except:
            from youloc.userprofile.models import UserProfile
            profile = UserProfile.objects.create(user=request.user)
            profile.save()
        profile = UserProfileForm(instance=profile)
    form1 = OpenidSigninForm()
    form2 = AuthenticationForm()
    try:
        latestlocation = LatestLocation.objects.get(user=request.user)
        geoname = reverse_geonames_lookup(latestlocation.latitude, latestlocation.longitude)
    except:
        latestlocation = False
        geoname = ''
    return render("home.html", {
        'form1': form1,
        'form2': form2,
        'location': latestlocation,
        'geoname': geoname,
        'profile': profile
    }, context_instance=RequestContext(request))

def profiletest(request):
    try:
        userprofile = request.user.get_profile()
    except:
        from youloc.userprofile.models import UserProfile
        userprofile = UserProfile.objects.create(user=request.user)
        userprofile.save()
    return HttpResponse("Yay?")