var lat=61.68
var lon=26.37
var zoom=7;
var second=1000;
var users = null;
var map;
var first_center = 0;


$(document).ready(function(){
        /* Bind nav-bar */
        $("a[href=#users]").click(function() { listUsers(); return 0; }, function () {} );
        $("a[href=#locate]").click(function() { locateUser(1); return 0; }, function () {} );
        /*  Create map-object */
	map = new OpenLayers.Map ("map", {
			controls:[
				new OpenLayers.Control.Navigation(),
				new OpenLayers.Control.PanZoomBar(),
				new OpenLayers.Control.LayerSwitcher(),
				new OpenLayers.Control.KeyboardDefaults()],
			maxExtent: new OpenLayers.Bounds(-20037508.34,-20037508.34,20037508.34,20037508.34),
			maxResolution: 156543.0399,
			numZoomLevels: 19,
			units: 'm',
			projection: new OpenLayers.Projection("EPSG:900913"),
			displayProjection: new OpenLayers.Projection("EPSG:4326")
		} );


	/* Specify layers for map and KML layer for users*/
	layerMapnik = new OpenLayers.Layer.OSM.Mapnik("Mapnik");
	layerOsmarender = new OpenLayers.Layer.OSM.Osmarender("Osmarender");
	layerCycleMap = new OpenLayers.Layer.OSM.CycleMap("CycleMap");

	users = new OpenLayers.Layer.Vector("Users", {
		projection: map.displayProjection,
		eventListeners: { 'loadend': userLoadFinished },
		strategies: [new OpenLayers.Strategy.Fixed()],
		protocol: new OpenLayers.Protocol.HTTP({
			url: "/users.kml"+"?"+Math.random(),
			format: new OpenLayers.Format.KML({
				extractStyles: true,
				extractAttributes: true
			})
		})
	});

	/* OpenLayers examples */
        select = new OpenLayers.Control.SelectFeature(users);
        users.events.on({
            "featureselected": userIconClicked,
            "featureunselected": onFeatureUnselect
        });

        map.addControl(select);
        select.activate();
	/* /end of OpenLayers examples */


	map.addLayers([layerMapnik, layerOsmarender, layerCycleMap, users]);

	autoUpdate();
});

function listUsers() {
	$('div.info').show();
	$('div.info').html("loading");
	$.ajax({
		type: "GET",
		url: "/users.kml",
		dataType: "xml",
		success: parseUserKml
	});
}

function parseUserKml(xml) {
	$('div.info').html("");
	$(xml).find("Placemark").each(function(){
		content = "<img src=\""+$(this).find("gravatar").text()+"\" alt=\"\" /> <a href=\"#\" onclick=\"mapSetCenter("+$(this).find("latitude").text()+","+$(this).find("longitude").text()+",15); return false;\">"+$(this).find("name").text()+"</a><br />";
		$('div.info').append(content);
	});

}


function userIconClicked(event) {
	var userinfo = event.feature;
	var username = userinfo.attributes.name;
	var content = userinfo.attributes.description;

	$('div.info').show();
	$('div.info').html(content);
        map.setCenter(userinfo.geometry.getBounds().getCenterLonLat(), 15);
}

function onFeatureUnselect(event) {
	$('div.info').html("");
	$('div.info').hide();
}


function mapSetCenter(latitude, longitude, zoom) {
	zoom = typeof(zoom) != 'undefined' ? zoom : 10;
	var lonLat = new OpenLayers.LonLat(longitude, latitude).transform(new OpenLayers.Projection("EPSG:4326"), map.getProjectionObject());
        map.setCenter(lonLat, zoom);
}


function locateUser(center) {
	center = typeof(center) != 'undefined' ? center : 0;
	if (navigator.geolocation) {
	var lat;
	var lng;
          navigator.geolocation.getCurrentPosition(function(position) {
            lat = position.coords.latitude;
            lng = position.coords.longitude;
	    if (center) {
		mapSetCenter(lat, lng, 15);
	    }
            $.post("/updatelocation/", { lat: lat, lon: lng },
	       function(data){
	           alert("Data Loaded: " + data);
	    });
          });
	}
}


function autoUpdate() {
	users.refresh(true);
	locateUser();
	setTimeout("autoUpdate()",10*second);
}


// unnecessary, need to merge with previous function if possible
function userLoadFinished () {
	if ( first_center == 0 ) {
		map.zoomToExtent(users.getDataExtent());
		first_center = 1;
	}
}
