# -*- coding: utf-8 -*-
from django.db import models
from django.forms import ModelForm
from django.contrib.auth.models import User

class UserProfile(models.Model):
    user = models.ForeignKey(User, unique=True) # Required
    def __unicode__(self):
        return self.user.username+"'s profile"
    VISIBILITY_CHOICES = ((0, 'Visible to everyone'), (1, 'Visible only to logged in users'), (2, 'Visible only to friends'), (3, 'Visible to no one'))
    location_visibility = models.IntegerField('Visibility of latest location', choices=VISIBILITY_CHOICES, default=0, null=False)
    track_visibility = models.IntegerField('Default visibility of tracks', choices=VISIBILITY_CHOICES, default=0, null=False)

class UserProfileForm(ModelForm):
    #def __init__(self, user, *args, **kwargs):
        #super(UserProfileForm, self).__init__(*args, **kwargs)
        #self.user = user
    class Meta:
        model = UserProfile
